{
  "name": "server",
  "version": "1.0.0",
  "description": "backend da plataforma proffy que une alunos e professores para aulas particulares online",
  "main": "index.js",
  "repository": "https://gitlab.com/sebas.sil/proffy.git",
  "author": "Fabio Sebastian Silveira <sebas.sil@gmail.com>",
  "license": "MIT",
  "private": false,
  "scripts": {
    "start": "tsnd --transpile-only --ignore-watch node_modules --respawn src/server.ts",
    "migration:make": "knex --knexfile=src/config/knex.ts migrate:make -x ts",
    "migration:run": "knex --knexfile=src/config/knex.ts migrate:latest",
    "verify": "eslint src/**",
    "test": "jest --verbose=true"
  },
  "devDependencies": {
    "@types/bcryptjs": "^2.4.2",
    "@types/cors": "^2.8.7",
    "@types/express": "^4.17.7",
    "@types/jsonwebtoken": "^8.5.0",
    "@types/nodemailer": "^6.4.0",
    "@types/request": "^2.48.5",
    "@types/supertest": "^2.0.10",
    "@typescript-eslint/eslint-plugin": "^4.0.1",
    "@typescript-eslint/parser": "^4.0.1",
    "axios": "^0.20.0",
    "eslint": "^7.8.1",
    "eslint-config-google": "^0.14.0",
    "jest": "^26.4.2",
    "supertest": "^4.0.2",
    "ts-jest": "^26.3.0",
    "ts-node-dev": "^1.0.0-pre.60",
    "typescript": "^4.0.2"
  },
  "dependencies": {
    "bcryptjs": "^2.4.3",
    "cors": "^2.8.5",
    "dotenv": "^8.2.0",
    "express": "^4.17.1",
    "jsonwebtoken": "^8.5.1",
    "knex": "^0.21.5",
    "nodemailer": "^6.4.11",
    "nodemailer-express-handlebars": "^4.0.0",
    "sqlite3": "^5.0.0"
  },
  "comments": {
    "scripts": {
      "start": "Start the server whatching file changes and ignoring changes of node_modules",
      "migration:make": "Used to create a new migration file of knex",
      "migration:run": "Used to run all migrations that didnt run yet",
      "verify": "Run eslint to verify code styles",
      "test": "",
      "coverage": ""
    },
    "devDependencies": {
      "ts-node-dev": "It restarts target node process when any of required files changes",
      "typescript": "Adds optional types to JavaScript that support tools for large-scale JavaScript applications for any browser",
      "jest": "Framework to write unit tests",
      "ts-jest": "Add TypeScript support to jest",
      "eslint": "Linter tool for identifying and reporting on patterns in JavaScript"
    },
    "dependencies": {
      "cors": "Encharged to specify to the browser the ways for a server allowing its resources to be accessed by a web page from a different domain (this case, from app and web)",
      "express": "Web applications framework to create a server",
      "knex": "SQL query builder for databases. It's replaces the need for write a raw database query",
      "sqlite3": "Database file based, the simplest way to save things",
      "bcryptjs": "Used to encrypt the user password",
      "jsonwebtoken": "Official package for JWT",
      "dotenv": "Loads environment variables from a .env file into process.env. Used to store project variables",
      "nodemailer": "Email sending",
      "nodemailer-express-handlebars": "Plugin of nodemailer use templates to generate html emails."
    }
  }
}
